library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

-- pwm_top beinhaltet jetzt die Module
-- pwm
-- und
-- jcounter
-- Verbindung ueber das Signal dout
-- alle uebrigen Signale werden aus dem Modul pwm_top rausgefuehrt
entity pwm_top is
   port 
   (
      clk     : in std_logic;
      pwm_out : out std_logic
   );
end;



architecture behave of pwm_top is

   
   component jcounter
      port
      (
         clk  : in std_logic;
         dout : buffer std_logic_vector(7 downto 0)
      );
   end component;
   
   
   component pwm
      port (
         clk     : in std_logic;
         PWM_in  : in std_logic_vector (7 downto 0) := "00000000";
         PWM_out : out std_logic
      );
   end component;
   
   signal dout : std_logic_vector(7 downto 0);
   

  
begin

   jcounter_unit : jcounter
      port map
      (
         clk  => clk,
         dout => dout
      );

   pwm_unit : pwm
      port map
      (
         clk     => clk,
         pwm_in  => dout, -- Ausgang vom jcounter hier als Input
         pwm_out => pwm_out
      );
end;

